<?php

namespace Drupal\wsolution\Plugin\rest\resource;

use Drupal\Core\Cache\CacheableMetadata;
use Drupal\rest\Plugin\ResourceBase;
use Drupal\rest\ResourceResponse;

/**
 * Provides a Demo Resource
 *
 * @RestResource(
 *   id = "wsolution_demo_rest",
 *   label = @Translation("Wsotuion test Resource"),
 *   uri_paths = {
 *     "canonical" = "/wsolution/test-rest-plugin"
 *   }
 * )
 */
class DemoResource extends ResourceBase {

  /**
   * Responds to entity GET requests.
   *
   * @return \Drupal\rest\ResourceResponse
   */
  public function get() {
    $response = ['message' => 'Hello, this is a rest service'];
    $response = new ResourceResponse($response);
    $response->addCacheableDependency((new CacheableMetadata())->setCacheMaxAge(0));
    return new $response;
  }

}
