<?php

namespace Drupal\wsolution_elastic\PasseplatElastic\Service;

use PassePlat\Logger\Elastic\Exception\ElasticsearchException;
use PassePlat\Logger\Elastic\Service\ElasticsearchService;

/**
 * This service class manages the interactions with an Elasticsearch, providing
 * functionality to configure the client, prepare indices, and log data into
 * Elasticsearch.
 */
class DrupalElasticsearchService extends ElasticsearchService {

  /**
   * Gets the Elasticsearch configs.
   *
   * @throws ElasticsearchException
   */
  public function setConfigs(): void {
    try {
      $wsolution_elastic = \Drupal::entityTypeManager()
        ->getStorage('wsolution_elastic')
        ->loadMultiple();
      $configs = [];
      foreach ($wsolution_elastic as $wsolution_elastic_entity) {
        $configs['hosts'][] = $wsolution_elastic_entity->toArray();
      }
      $this->configs = $configs;
    }
    catch (\Exception $e) {
      throw new ElasticsearchException('Cannot retrieve the ES configs.', $e);
    }
  }

}
