<?php

namespace Drupal\wsolution\Passeplat\Security;

use Dakwamine\Component\Exception\UnmetDependencyException;
use Dakwamine\Component\RootDependencyDefinition;
use Drupal\wsolution\Passeplat\Config\Configuration;
use Psr\Http\Message\UriInterface;
use PassePlat\Core\Security\HostChecker as BaseHostChecker;

/**
 * Provides checks on the host.
 */
class HostChecker extends BaseHostChecker
{

    public function getDependencyDefinitions(): array
    {
        $definitions = parent::getDependencyDefinitions();
        $definitions[] = new RootDependencyDefinition(Configuration::class, $this->configuration);
        return $definitions;
    }

    /**
     * Gets the host type from the given URL.
     *
     * @param UriInterface $uri
     *   The URI object containing URL info.
     * @param bool $recheck
     *   Set to true to check again if already checked once. When false, it will use the cached result.
     *
     * @return string
     *   Host type, one of HostCheckerInterface::* consts.
     *
     * @throws UnmetDependencyException
     */
    public function getHostTypeFromUrl(UriInterface $uri, bool $recheck = false): string
    {
      //@todo review the parent methode based o trusted host
      return static::HOST_TYPE__WITH_DESTINATION;
    }
}
