<?php

namespace Drupal\wsolution\Passeplat\StreamProcessor;

use Dakwamine\Component\Event\EventDispatcher;
use Dakwamine\Component\RootDependencyDefinition;
use PassePlat\Core\PassePlatResponseFactory;
use PassePlat\Core\Security\HostChecker;
use PassePlat\Core\StreamProcessor\StreamProcessor as CoreStreamProcessor;
use Drupal\wsolution\Passeplat\Webservice\WebServiceManager;

class StreamProcessor extends CoreStreamProcessor {
  public function getDependencyDefinitions(): array
  {
    $definitions = parent::getDependencyDefinitions();
    $definitions[] = new RootDependencyDefinition(EventDispatcher::class, $this->eventDispatcher);
    $definitions[] = new RootDependencyDefinition(HostChecker::class, $this->hostChecker);
    $definitions[] = new RootDependencyDefinition(PassePlatResponseFactory::class, $this->passePlatResponseFactory);
    $definitions[] = new RootDependencyDefinition(WebServiceManager::class, $this->webServiceManager);
    return $definitions;
  }

}
